//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                    http://fx500.ru/silverfox |
//+----------------------------------------------+
#property copyright "Copyright  2011, Evgeno"
#property link      "http://fx500.ru/silverfox"

void DoTrallingStop(int TStop=-1,int TStep=-1){
   if(TStop==-1) TStop=TrallingStop;
   if(TStep==-1) TStop=TrallingStep;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol()){
         RefreshRates();
         if((Bid>OrderOpenPrice()+TStop*Point+TStep*Point && OrderStopLoss()==0)||(Bid>OrderStopLoss()+TStop*Point+TStep*Point && OrderStopLoss()>0)){
            OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TStop*Point,OrderTakeProfit(),0);
            }
         }
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol()){
         RefreshRates();
         if((Ask<OrderOpenPrice()-TStop*Point-TStep*Point && OrderStopLoss()==0)||(Ask<OrderStopLoss()-TStop*Point-TStep*Point && OrderStopLoss()>0)){
            OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TStop*Point,OrderTakeProfit(),0);
            }
         }
      }
   return;
   }

void Reverse2Check(){
   if(Sells()>0){
      DeleteBuyStops();
      }
   if(Buys()>0){
      DeleteSellStops();
      }
   }

void CheckLines(){
   for(int i=1;i<=LineLimit;i++){
      if(ObjectFind("__LineStop_UP"+DoubleToStr(i,0))!=-1){
         RefreshRates();
         if(ObjectGet("__LineStop_UP"+DoubleToStr(i,0),OBJPROP_PRICE1)<=Ask)
            {
            OpBuy();
            ObjectDelete("__LineStop_UP"+DoubleToStr(i,0));
            }
         }
      if(ObjectFind("__LineStop_DN"+DoubleToStr(i,0))!=-1){
         RefreshRates();
         if(ObjectGet("__LineStop_DN"+DoubleToStr(i,0),OBJPROP_PRICE1)>=Bid)
            {
            OpSell();
            ObjectDelete("__LineStop_DN"+DoubleToStr(i,0));
            }
         }
      if(ObjectFind("__LineExit_UP"+DoubleToStr(i,0))!=-1){
         RefreshRates();
         if(ObjectGet("__LineExit_UP"+DoubleToStr(i,0),OBJPROP_PRICE1)<=Ask)
         CloseSells();
         if(ObjectGet("__LineExit_UP"+DoubleToStr(i,0),OBJPROP_PRICE1)<=Bid){
            CloseBuys();
            ObjectDelete("__LineExit_UP"+DoubleToStr(i,0));
            }
         }
      if(ObjectFind("__LineExit_DN"+DoubleToStr(i,0))!=-1){
         RefreshRates();
         if(ObjectGet("__LineExit_DN"+DoubleToStr(i,0),OBJPROP_PRICE1)>=Bid)
         CloseBuys();
         if(ObjectGet("__LineExit_DN"+DoubleToStr(i,0),OBJPROP_PRICE1)>=Ask){
            CloseSells();
            ObjectDelete("__LineExit_DN"+DoubleToStr(i,0));
            }
         }
      }
   }

void TickEvent(){
   int j;
   if(XProfit>0){
      for(int i=1;i<=OrdersTotal();i--){
         OrderSelect(i,SELECT_BY_POS);
         if(OrderSymbol()==Symbol()){
            if(OrderType()==OP_BUY){
               RefreshRates();
               if(Bid>=OrderOpenPrice()+XProfit*Point){
                  for(j=1;j<=Requots;j++){
                     RefreshRates();
                     if(OrderClose(OrderTicket(),OrderLots(),Bid,Slippage)==true){
                        j=Requots+1;
                        PlaySound(SND_Close);
                        }
                     }
                  }
               }
            if(OrderType()==OP_SELL){
               RefreshRates();
               if(Ask<=OrderOpenPrice()-XProfit*Point){
                  for(j=1;j<=Requots;j++){
                     RefreshRates();
                     if(OrderClose(OrderTicket(),OrderLots(),Ask,Slippage)==true){
                        j=Requots+1;
                        PlaySound(SND_Close);
                        }
                     }
                  }
               }
            }
         }
      }
   return;
   }
//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                    http://fx500.ru/silverfox |
//+----------------------------------------------+

