//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                    http://fx500.ru/silverfox |
//+----------------------------------------------+
#property copyright "Copyright  2011, Evgeno"
#property link      "http://fx500.ru/silverfox"

void ReviseMasks(){
   int j;
   double Proc,SL,TP;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderSymbol()==Symbol()){
         if(OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP){
            if(ObjectFind("__Mask_Open_"+DoubleToStr(OrderTicket(),0))!=-1){
               if(ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1)!=OrderOpenPrice()){
                  Proc=ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1)-OrderOpenPrice();
                  if(OrderStopLoss()>0) SL=NormalizeDouble(OrderStopLoss()+Proc,Digits); else SL=0;
                  if(OrderTakeProfit()>0) TP=NormalizeDouble(OrderTakeProfit()+Proc,Digits); else TP=0;
                  OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice()+Proc,Digits),SL,TP,0);
                  if(UseSound==true) PlaySound(SND_Modify);
                  
                  OrderSelect(OrderTicket(),SELECT_BY_TICKET);
                  ObjectCreate("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderOpenPrice());
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskOpen);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
                  
                  ObjectCreate("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
                  ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderStopLoss());
                  ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskSL);
                  ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
                  ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
                  
                  ObjectCreate("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
                  ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderTakeProfit());
                  ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskTP);
                  ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
                  ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
                  
                  }
               }//Object Found
               else{
               if(OrderOpenTime()>TimeCurrent()-InterVal){
                  ObjectCreate("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderOpenPrice()+Proc);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskOpen);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
                  }
                  else if(UserConf(":"+DoubleToStr(OrderTicket(),0)+"  !!!"," ")==true){
                  OrderDelete(OrderTicket());
                  if(UseSound==true) PlaySound(SND_Pend);
                  ObjectDelete("__Mask_Open_"+DoubleToStr(OrderTicket(),0));
                  ObjectDelete("__Mask_SL_"+DoubleToStr(OrderTicket(),0));
                  ObjectDelete("__Mask_TP_"+DoubleToStr(OrderTicket(),0));
                  }else{
                  ObjectCreate("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderOpenPrice()+Proc);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskOpen);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
                  }
               }
            }//BUY STOP
         if(OrderType()==OP_BUY){
            if(ObjectFind("__Mask_Open_"+DoubleToStr(OrderTicket(),0))!=-1){
               if(ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1)!=OrderOpenPrice()){
                  if(ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1)>Ask){
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1),0);
                     if(UseSound==true) PlaySound(SND_Modify);
                     ObjectCreate("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
                     ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1));
                     ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskTP);
                     ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
                     ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
                     ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderOpenPrice());
                     }//Price >Ask
                  else if(ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1)<Bid){
                     OrderModify(OrderTicket(),OrderOpenPrice(),ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1),OrderTakeProfit(),0);
                     if(UseSound==true) PlaySound(SND_Modify);
                     ObjectCreate("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
                     ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1));
                     ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskSL);
                     ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
                     ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
                     ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderOpenPrice());
                     }//Price <Bid
                  }//OpenPrice Moved
               }//OBJ_Find
               else{
               if(OrderOpenTime()>TimeCurrent()-InterVal){
                  ObjectCreate("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderOpenPrice());
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskOpen);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
                  }//InterVal
                  else{
                  RefreshRates();
                  if(UserConf(":"+DoubleToStr(OrderTicket(),0)+"  !!!"," ")==true)
                  for(j=1;j<=Requotes;j++){
                     if(OrderClose(OrderTicket(),OrderLots(),Bid,Slippage)==true){
                        if(UseSound==true) PlaySound(SND_Close);
                        j=Requotes+1;
                        ObjectDelete("__Mask_Open_"+DoubleToStr(OrderTicket(),0));
                        ObjectDelete("__Mask_SL_"+DoubleToStr(OrderTicket(),0));
                        ObjectDelete("__Mask_TP_"+DoubleToStr(OrderTicket(),0));
                        }
                     }else{
                     ObjectCreate("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
                     ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderOpenPrice()+Proc);
                     ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskOpen);
                     ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
                     ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
                     }
                  }//InterVal Else
               }//Else
            }//OP_BUY
         if(OrderType()==OP_SELL){
            if(ObjectFind("__Mask_Open_"+DoubleToStr(OrderTicket(),0))!=-1){
               if(ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1)!=OrderOpenPrice()){
                  if(ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1)<Bid){
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1),0);
                     if(UseSound==true) PlaySound(SND_Modify);
                     ObjectCreate("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
                     ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1));
                     ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskTP);
                     ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
                     ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
                     ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderOpenPrice());
                     }//Price >Ask
                  else if(ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1)>Ask){
                     OrderModify(OrderTicket(),OrderOpenPrice(),ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1),OrderTakeProfit(),0);
                     if(UseSound==true) PlaySound(SND_Modify);
                     ObjectCreate("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
                     ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,ObjectGet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1));
                     ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskSL);
                     ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
                     ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
                     ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderOpenPrice());
                     }//Price <Bid
                  }//OpenPrice Moved
               }//OBJ_Find
               else{
               if(OrderOpenTime()>TimeCurrent()-InterVal){
                  ObjectCreate("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderOpenPrice());
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskOpen);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
                  ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
                  }//InterVal
                  else{
                  RefreshRates();
                  if(UserConf(":"+DoubleToStr(OrderTicket(),0)+"  !!!"," ")==true)
                  for(j=1;j<=Requotes;j++){
                     if(OrderClose(OrderTicket(),OrderLots(),Ask,Slippage)==true){
                        if(UseSound==true) PlaySound(SND_Close);
                        j=Requotes+1;
                        ObjectDelete("__Mask_Open_"+DoubleToStr(OrderTicket(),0));
                        ObjectDelete("__Mask_SL_"+DoubleToStr(OrderTicket(),0));
                        ObjectDelete("__Mask_TP_"+DoubleToStr(OrderTicket(),0));
                        }
                     }else{
                     ObjectCreate("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
                     ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderOpenPrice()+Proc);
                     ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskOpen);
                     ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
                     ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
                     }
                  }//InterVal Else
               }//Else
            }//OP_SELL
         if(ObjectFind("__Mask_SL_"+DoubleToStr(OrderTicket(),0))!=-1 && ObjectGet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1)!=OrderStopLoss()){
            OrderModify(OrderTicket(),OrderOpenPrice(),ObjectGet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1),OrderTakeProfit(),0);
            if(UseSound==true) PlaySound(SND_Modify);
            }
         if(ObjectFind("__Mask_TP_"+DoubleToStr(OrderTicket(),0))!=-1 && ObjectGet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1)!=OrderTakeProfit()){
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),ObjectGet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1),0);
            if(UseSound==true) PlaySound(SND_Modify);
            }
         if(OrderOpenTime()<TimeCurrent()-InterVal && ObjectFind("__Mask_Open_"+DoubleToStr(OrderTicket(),0))!=-1){
            if(ObjectFind("__Mask_SL_"+DoubleToStr(OrderTicket(),0))==-1){
               OrderModify(OrderTicket(),OrderOpenPrice(),0,OrderTakeProfit(),0);
               if(UseSound==true) PlaySound(SND_Modify);
               }
            if(ObjectFind("__Mask_TP_"+DoubleToStr(OrderTicket(),0))==-1){
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),0,0);
               if(UseSound==true) PlaySound(SND_Modify);
               }
            }
         OrderSelect(OrderTicket(),SELECT_BY_TICKET);
         ObjectCreate("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
         ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderStopLoss());
         ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskSL);
         ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
         ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
         
         ObjectCreate("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
         ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderTakeProfit());
         ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskTP);
         ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
         ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
         }//OrderSymb
      }//Cicle
   }//FNC

void MaskOn(){
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderSymbol()==Symbol()){
         if(ObjectFind("__Mask_Open_"+DoubleToStr(OrderTicket(),0))==-1){
            ObjectCreate("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
            ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderOpenPrice());
            ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskOpen);
            ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
            ObjectSet("__Mask_Open_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
            }
         if(ObjectFind("__Mask_SL_"+DoubleToStr(OrderTicket(),0))==-1 && OrderStopLoss()>0){
            ObjectCreate("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
            ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderStopLoss());
            ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskSL);
            ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
            ObjectSet("__Mask_SL_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
            }
         if(ObjectFind("__Mask_TP_"+DoubleToStr(OrderTicket(),0))==-1 && OrderTakeProfit()>0){
            ObjectCreate("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJ_HLINE,0,0,0);
            ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_PRICE1,OrderTakeProfit());
            ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_COLOR,CL_MaskTP);
            ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_WIDTH,1);
            ObjectSet("__Mask_TP_"+DoubleToStr(OrderTicket(),0),OBJPROP_STYLE,3);
            }
         }
      }
   }

void NurseMasks(){
   string Name3;
   for(int i=ObjectsTotal()-1;i>=0;i--){
      string Name=ObjectName(i);
      string Name1=StringSubstr(Name,0,7);
      if(Name1=="__Mask_"){
         string Name2=StringSubstr(Name,7,2);
         if(Name2=="Op") Name3=StringSubstr(Name,12);
         else Name3=StringSubstr(Name,10);
         int Tic=StrToInteger(Name3);
         if(OrderSelect(Tic,SELECT_BY_TICKET)==false){
            ObjectDelete(Name);
            }
         if(OrderCloseTime()>0){
            ObjectDelete(Name);
            }
         }
      }
   }
 
void KillMasks(){
   string Name3;
   for(int i=ObjectsTotal()-1;i>=0;i--){
      string Name=ObjectName(i);
      string Name1=StringSubstr(Name,0,7);
      if(Name1=="__Mask_"){
         ObjectDelete(Name);
         }
      }
   }   
//+----------------------------------------------+
//|                     Copyright  2011, Evgeno |
//|                    http://fx500.ru/silverfox |
//+----------------------------------------------+



